libidn: idna.c File Reference

libidn 1.41

Macros | Functions
idna.c File Reference
`#include <stdlib.h>`
`#include <string.h>`
`#include <stringprep.h>`
`#include <punycode.h>`
`#include "idna.h"`
`#include <c-strcase.h>`

Go to the source code of this file.

## Macros
#define | DOTP(c)

## Functions
int | idna_to_ascii_4i (const uint32_t *in, size_t inlen, char *out, int flags)
int | idna_to_unicode_44i (const uint32_t *in, size_t inlen, uint32_t *out, size_t *outlen, int flags)
int | idna_to_ascii_4z (const uint32_t *input, char **output, int flags)
int | idna_to_ascii_8z (const char *input, char **output, int flags)
int | idna_to_ascii_lz (const char *input, char **output, int flags)
int | idna_to_unicode_4z4z (const uint32_t *input, uint32_t **output, int flags)
int | idna_to_unicode_8z4z (const char *input, uint32_t **output, int flags)
int | idna_to_unicode_8z8z (const char *input, char **output, int flags)
int | idna_to_unicode_8zlz (const char *input, char **output, int flags)
int | idna_to_unicode_lzlz (const char *input, char **output, int flags)

## Macro Definition Documentation

## ◆ DOTP

#define DOTP | ( |  | c | ) |

Value:
((c) == 0x002E || (c) == 0x3002 || \
(c) == 0xFF0E || (c) == 0xFF61)

Definition at line 44 of file idna.c.

## Function Documentation

## ◆ idna_to_ascii_4i()

int idna_to_ascii_4i | ( | const uint32_t * | in,
|  | size_t | inlen,
|  | char * | out,
|  | int | flags
| ) |  |

idna_to_ascii_4i:

Parameters

  in | input array with unicode code points.
  inlen | length of input array with unicode code points.
  out | output zero terminated string that must have room for at least 63 characters plus the terminating zero.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

The ToASCII operation takes a sequence of Unicode code points that make up one domain label and transforms it into a sequence of code points in the ASCII range (0..7F). If ToASCII succeeds, the original sequence and the resulting sequence are equivalent labels.

It is important to note that the ToASCII operation can fail. ToASCII fails if any step of it fails. If any step of the ToASCII operation fails on any label in a domain name, that domain name MUST NOT be used as an internationalized domain name. The method for deadling with this failure is application-specific.

The inputs to ToASCII are a sequence of code points, the AllowUnassigned flag, and the UseSTD3ASCIIRules flag. The output of ToASCII is either a sequence of ASCII code points or a failure condition.

ToASCII never alters a sequence of code points that are all in the ASCII range to begin with (although it could fail). Applying the ToASCII operation multiple times has exactly the same effect as applying it just once.

Return value: Returns 0 on success, or an Idna_rc error code.

Definition at line 81 of file idna.c.

## ◆ idna_to_ascii_4z()

int idna_to_ascii_4z | ( | const uint32_t * | input,
|  | char ** | output,
|  | int | flags
| ) |  |

idna_to_ascii_4z:

Parameters

  input | zero terminated input Unicode string.
  output | pointer to newly allocated output string.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert UCS-4 domain name to ASCII string. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 477 of file idna.c.

## ◆ idna_to_ascii_8z()

int idna_to_ascii_8z | ( | const char * | input,
|  | char ** | output,
|  | int | flags
| ) |  |

idna_to_ascii_8z:

Parameters

  input | zero terminated input UTF-8 string.
  output | pointer to newly allocated output string.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert UTF-8 domain name to ASCII string. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 576 of file idna.c.

## ◆ idna_to_ascii_lz()

int idna_to_ascii_lz | ( | const char * | input,
|  | char ** | output,
|  | int | flags
| ) |  |

idna_to_ascii_lz:

Parameters

  input | zero terminated input string encoded in the current locale's character set.
  output | pointer to newly allocated output string.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert domain name in the locale's encoding to ASCII string. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 609 of file idna.c.

## ◆ idna_to_unicode_44i()

int idna_to_unicode_44i | ( | const uint32_t * | in,
|  | size_t | inlen,
|  | uint32_t * | out,
|  | size_t * | outlen,
|  | int | flags
| ) |  |

idna_to_unicode_44i:

Parameters

  in | input array with unicode code points.
  inlen | length of input array with unicode code points.
  out | output array with unicode code points.
  outlen | on input, maximum size of output array with unicode code points, on exit, actual size of output array with unicode code points.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

The ToUnicode operation takes a sequence of Unicode code points that make up one domain label and returns a sequence of Unicode code points. If the input sequence is a label in ACE form, then the result is an equivalent internationalized label that is not in ACE form, otherwise the original sequence is returned unaltered.

ToUnicode never fails. If any step fails, then the original input sequence is returned immediately in that step.

The Punycode decoder can never output more code points than it inputs, but Nameprep can, and therefore ToUnicode can. Note that the number of octets needed to represent a sequence of code points depends on the particular character encoding used.

The inputs to ToUnicode are a sequence of code points, the AllowUnassigned flag, and the UseSTD3ASCIIRules flag. The output of ToUnicode is always a sequence of Unicode code points.

Return value: Returns Idna_rc error condition, but it must only be used for debugging purposes. The output buffer is always guaranteed to contain the correct data according to the specification (sans malloc induced errors). NB! This means that you normally ignore the return code from this function, as checking it means breaking the standard.

Definition at line 437 of file idna.c.

## ◆ idna_to_unicode_4z4z()

int idna_to_unicode_4z4z | ( | const uint32_t * | input,
|  | uint32_t ** | output,
|  | int | flags
| ) |  |

idna_to_unicode_4z4z:

Parameters

  input | zero-terminated Unicode string.
  output | pointer to newly allocated output Unicode string.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert possibly ACE encoded domain name in UCS-4 format into a UCS-4 string. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 640 of file idna.c.

## ◆ idna_to_unicode_8z4z()

int idna_to_unicode_8z4z | ( | const char * | input,
|  | uint32_t ** | output,
|  | int | flags
| ) |  |

idna_to_unicode_8z4z:

Parameters

  input | zero-terminated UTF-8 string.
  output | pointer to newly allocated output Unicode string.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert possibly ACE encoded domain name in UTF-8 format into a UCS-4 string. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 719 of file idna.c.

## ◆ idna_to_unicode_8z8z()

int idna_to_unicode_8z8z | ( | const char * | input,
|  | char ** | output,
|  | int | flags
| ) |  |

idna_to_unicode_8z8z:

Parameters

  input | zero-terminated UTF-8 string.
  output | pointer to newly allocated output UTF-8 string.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert possibly ACE encoded domain name in UTF-8 format into a UTF-8 string. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 750 of file idna.c.

## ◆ idna_to_unicode_8zlz()

int idna_to_unicode_8zlz | ( | const char * | input,
|  | char ** | output,
|  | int | flags
| ) |  |

idna_to_unicode_8zlz:

Parameters

  input | zero-terminated UTF-8 string.
  output | pointer to newly allocated output string encoded in the current locale's character set.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert possibly ACE encoded domain name in UTF-8 format into a string encoded in the current locale's character set. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 784 of file idna.c.

## ◆ idna_to_unicode_lzlz()

int idna_to_unicode_lzlz | ( | const char * | input,
|  | char ** | output,
|  | int | flags
| ) |  |

idna_to_unicode_lzlz:

Parameters

  input | zero-terminated string encoded in the current locale's character set.
  output | pointer to newly allocated output string encoded in the current locale's character set.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert possibly ACE encoded domain name in the locale's character set into a string encoded in the current locale's character set. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 819 of file idna.c.